a4_rng = {}

local shot_init = 0
local shot_end = 0
local shot_hit = 0
local hit_ratio = 0
local flag = 1   --- per qualche ragione gli eventi SHOOTING_START e _END li triggera 2 volte 
local flag2= 0   --- quindi ho aggiunto queste due flag per considerare solo il 1° evento
local target = ""

sparo = {}
function sparo:onEvent(evento)
	if evento.id ==  world.event.S_EVENT_SHOOTING_START and evento.initiator:getName() == "User" and flag==1 then
		shot_init = a4_rng.ammo_count()
		flag = 0
		flag2 = 1
	end

	if evento.id ==  world.event.S_EVENT_SHOOTING_END and evento.initiator:getName() == "User" and flag2==1 then		
		shot_end = shot_init - a4_rng.ammo_count()
		hit_ratio = math.floor (shot_hit/shot_end*100)
		shot_hit = 0
		flag = 1
		flag2 = 0
	end
end
world.addEventHandler(sparo)

colpito = {}
function colpito:onEvent(evento)
	if evento.id == world.event.S_EVENT_HIT and evento.target:getName() == target then
		shot_hit = shot_hit +1
		trigger.action.outSound("beep-short.ogg")
	end
end
world.addEventHandler(colpito)

function a4_rng.def_tgt()
	local k = trigger.misc.getUserFlag(10)
	target = "tgt"..k
	Group.activate(Group.getByName(target))
end

function a4_rng.ammo_count()
	if Unit.getByName("User"):getAmmo() then
		user = Unit.getByName("User"):getAmmo()
		if user[1] and user[1]["count"] then
			return user[1]["count"]
		end
	else
		return 0
	end
end


function a4_rng.slant_dist()
	local user = Unit.getByName("User"):getPoint()
	local tgt = Unit.getByName(target):getPoint()
	local dist = math.floor(math.sqrt( (user.x-tgt.x)^2 + (user.y-tgt.y)^2 + (user.z-tgt.z)^2 ))
	return dist
end


function a4_rng.display()
	local testo = "DIST:"
	local d= math.floor(a4_rng.slant_dist())
	local dist = math.min(d,1001)
	local pieno = math.floor(dist/20)
	local mezzo = math.floor(dist%20/10)
	for i =1,pieno do
		testo = testo .. '█' 
	end
	if mezzo == 1 then 
		testo = testo .. '▌' 
		pieno = pieno +1
	end
	for i = pieno+1, 50 do
		testo = testo .. '░'
	end
	testo = testo .."  ".. d 
	testo = testo .. "\n        |        1        2        3        4        5        6        7        8        9        | x100mt\n" 
	testo = testo .. "Rounds: ".. a4_rng.ammo_count().."\n"
	testo = testo .. "Burst: " .. shot_end .. "   Hit ratio: ".. hit_ratio.. "%"
	
	trigger.action.outText(testo,2,true)
end

function a4_rng.disp_sched()
	local t = timer.getTime()
	for i=t + 0.25, t+1, 0.25 do
		timer.scheduleFunction(a4_rng.display,'',i)
	end	 
end	
	
	